import Registry from './registry/registry';
import Resolver from './resolver/resolver';
import Scope from './scope';
export default class Container {
    constructor(registry, resolver) {
        this.registry = registry;
        this.resolver = resolver;
    }
    static create() {
        const registry = new Registry();
        const resolver = new Resolver();
        return new Container(registry, resolver);
    }
    register(key, provider) {
        this.registry.register(key, provider, Scope.Prototype);
        return this;
    }
    registerSingleton(key, provider) {
        this.registry.register(key, provider, Scope.Singleton);
        return this;
    }
    get(key) {
        return this.resolver.resolve(this, this.registry, key);
    }
}
