export default class Registry {
    constructor() {
        this.registrations = new Map();
        this.instances = new Map();
    }
    register(key, provider, scope) {
        const registration = { key, provider, scope };
        this.registrations.set(key, registration);
        return registration;
    }
    registerInstance(key, instance) {
        this.instances.set(key, instance);
    }
    get(key) {
        return this.registrations.get(key);
    }
    getInstance(key) {
        return this.instances.get(key);
    }
}
