import Resolve from './resolve';
export default class ResolveSingleton extends Resolve {
    execute(key) {
        const cachedInstance = this.registry.getInstance(key);
        if (cachedInstance) {
            return cachedInstance;
        }
        const instance = super.execute(key);
        this.registry.registerInstance(key, instance);
        return instance;
    }
}
