import { notFoundError } from '../errors';
class Resolve {
    constructor(container, registry, path) {
        this.container = container;
        this.registry = registry;
        this.path = path;
    }
    execute(key) {
        const registration = this.registry.get(key);
        if (!registration) {
            throw notFoundError(key);
        }
        try {
            this.path.push(key);
            return registration.provider(this.container);
        }
        finally {
            this.path.pop();
        }
    }
}
export default Resolve;
