import Path from './path';
import Resolve from './resolve';
import ResolveSingleton from './resolve-singleton';
import Scope from '../scope';
export default class Resolver {
    constructor() {
        this.path = new Path();
    }
    resolve(container, registry, key) {
        const registration = registry.get(key);
        let strategy;
        if (registration && registration.scope === Scope.Singleton) {
            strategy = new ResolveSingleton(container, registry, this.path);
        }
        else {
            strategy = new Resolve(container, registry, this.path);
        }
        return strategy.execute(key);
    }
}
